#include "common.h"

int main(void) {
	int sx,sy,M,k;
	int *x,*y;

	IN(BOUND(x,0,M),BOUND(y,0,M),M);

	ASSUME(GTE("_M","0"));
	sx = shift(0);
	sy = shift(1);
	k = 0;
	while (k < M) {
		x[k] = x[k] + sx;
		y[k] = y[k] + sy;
		k++;
	}

	OUT(x,y,M);
}

void inverted()
{
	int *x_,*y_,sx_,sy_,k_,M_;

	ASSUME(EQ("_x","_x_"));
	ASSUME(EQ("_y","_y_"));
	ASSUME(EQ("_M","_M_"));

	TS(sx_,sy_,k_);
	while (GUARD()) { 
		TS(x_, y_, k_);
	}

	OUT(BOUND(x_,0,M_),BOUND(y_,0,M_),M_);
}

int params () {
	char* MODE = "invert"; 
	char* predicates = 
		LT("_k_","_M_") ", "
		GT("_k_","0") ", "
		;
	char* expressions = 
		"(0):int, "
		"(_k_ + 1):int, "
		"(_shift 0):int, "
		"(_shift 1):int, "
		UPD("_x_","_k_",SUB(SEL("_x_","_k_"),"_sx_")) ":int*, "
		UPD("_y_","_k_",SUB(SEL("_y_","_k_"),"_sy_")) ":int*, "
		;
	char *KINDS = "int; string; clock; ";
	char *TYPES = "int* _x_,_y_; "; // the rest default to Int
	char *SYMS =
		"_BOUND:int->int->int->int; "
		"_shift:int->int; "
		;

  char* NOTES = 
	  "ExpectedSolution : "
	  " &&& "
	  "Benchmark : shift1";
}