void main()
{
	char *A;
	char *odata; // string *
    int e; // string
    int i,n,k,s;

	IN(BOUND(odata,0,n),n);

	ASSUME("(_n >= 0)");
	i = 0; k = 0;
    while(i < n) {
		e = odata[i++];
		s = size(e);
		A[k++] = s;
		A[k] = memcpy(e,s); // writes s bytes from e to A+k
		k += s;
	}

	OUT(A,k);
}

void inverted()
{
	char *data; // string*
	int ii,kk,ss,xx;

	TS(ii,kk);
	while(GUARD()) { 
		ASSUME("((_A sel _ii) > 0)");
		TS(ss,ii);
		TS(ii,data,kk);
	}

	OUT(BOUND(data,0,kk),kk);
}

int params () {
	char* MODE = "invert"; 
	char* predicates = 
		"(_ii < _k), "
		"(_kk > 0), "
		;
	char* expressions =
		"(0):int, "
		"(_A sel _ii):int, "
		"(_ii + 1):int, "
		"(_ii + _ss):int, "
		"(_kk + 1):int, "
		"(_data upd _kk upd ((_A sel _ii) _memread _ss)):string*, "
		;
	char *KINDS = "int; string; ";
	char *TYPES = "int* _A; string* _data,_odata; "; // the rest default to Int
	char *SYMS =
		"_BOUND:int->int->int->int; "
		"_size:string->int; "
		"_memcpy:string->int->string; "
		"_memread:string->int->string; "
		;
#include "pkt-axioms.h"

  char* NOTES = 
	  "ExpectedSolution : "
	  " &&& "
	  "Benchmark : pkt";
}