void main()
{
	char *A,*out;
    int s,e; // string
    int i,j,len,n,k;

	IN(BOUND(A,0,n),n);

	ASSUME("(_n >= 0)");
	j = 0; k = 0;
    while(j < n) {
        len = 0; i = 0; s = null(0);
        while (i < 3 && j < n) {
			s = append(s, A[j]); 
			i++; j++; len++;
        }
		e = encodeblock(s);
		i = 0; 
		while (i < 4) {
			if (i < len + 1)
				out[k++] = get(e,i);
			else 
				out[k++] = pad(0);
			i++;
		}
	}

	OUT(out,k);
}

void inverted()
{
	char *AA,*out_;
    int ss,d; // string
	int jj,nn;
	
	ASSUME("(_out_ == _out)");

	nn = 0; jj = 0;
	while(GUARD()) { 
		ss = null(0);
		TS(ss); jj++;
		TS(ss); jj++;
		TS(ss); jj++;
		TS(ss); jj++;
		d = decodeblock(ss);
		TS(AA,nn);
		if (GUARD()) 
			TS(AA,nn); 
		if (GUARD()) 
			TS(AA,nn); 
    }
	OUT(BOUND(AA,0,nn),nn);
}

int params () {
	char* MODE = "invert";
	char* predicates = 
		"(_jj < _k), "
		"((_d _get 1) != (_pad 0)), "
		"((_d _get 2) != (_pad 0)), "
		;
	char* expressions = 
		"(_ss _append (_out sel _jj)):string, "
		"(_jj + 1):int, "
		"(_nn + 1):int, "
		"(_AA upd _nn upd (_d _get 0)):int*, "
		"(_AA upd _nn upd (_d _get 1)):int*, "
		"(_AA upd _nn upd (_d _get 2)):int*, "
		;
	char *KINDS = "int; string; ";
	char *TYPES = "int* _AA; string _ss; "; // the rest default to Int
	char *SYMS =
		"_BOUND:int->int->int->int; "
		"_null:int->string; "
		"_pad:int->int; "
		"_append:string->int->string; "
		"_decodeblock:string->string; "
		"_encodeblock:string->string; "
		"_get:string->int->int"
		;
#include "base64-axioms.h"

  char* NOTES = 
	  "ExpectedSolution : "
	  " &&& "
	  "Benchmark : base64";
}