#include "common.h"
#define NULL "(_null 0)"
#define MEMCPY(x,Sx) "(" x " _memcpy " Sx ")"
#define MEMREAD(x,Sx) "(" x " _memread " Sx ")"
#define SIZE(E) "(_size " E ")"

char *AXIOMS =
FORALL(QUANT1(e), \
	   GTE(SIZE("e"),"1"), \
	   PATT1(SIZE("e"))) "; "

FORALL(QUANT4(x,Sx,e,Se), \
	   IMPLIES(AND3( \
					EQ("x",MEMCPY("e","Se")), \
					EQ("Se",SIZE("e")), \
					EQ("Se","Sx") \
			   ),
	           EQ(MEMREAD("x","Sx"),"e")), \
	   PATT1(ANDPATT2(MEMCPY("e","Se"), MEMREAD("x","Sx")))) "; "
;