void main()
{
	char *E,*data;
    int s,e; // string
    int i,n,k,len,M;

	IN(BOUND(data,0,n),n);

	ASSUME("(_n >= 0)");
	ASSUME("(_M >= 1)");
	E[0] = hdr(0);
	i = 0; k = 1;
    while(i < n) {
		if (i + M < n)
			len = M;
		else
			len = n - i;
		E[k++] = pair(len, encode(data[i], len));
		i = i + len;
	}
	E[k++] = ftr(0);

	OUT(E,k);
}

void inverted()
{
	char *d; // int *
	int ii,kk,xx;
	int llen, dec; // string

	xx = 1; kk = 0;
	while(GUARD()) { 
		TS(dec,llen,ii);
		while (GUARD()) { 
			TS(d,kk,ii); 
		}
		TS(xx); 
	}

	OUT(BOUND(d,0,kk),kk);
}

int params () {
	char* MODE = "invert";
	char* predicates = 
		"(_ii < _llen), "
		"(_xx < (_k - 1)), "
		;
	char* expressions = 
		"(_ii + 1):int, "
		"(_kk + 1):int, "
		"(_xx + 1):int, "
		"(0):int, "
		"(_fst (_E sel _xx)):string, "
		"(_decode (_snd (_E sel _xx))):string, "
		"(_d upd _kk upd (_dec _get _ii)):int*, "
		;
	char *KINDS = "int; string; ";
	char *TYPES = "int* _d; string _dec,_llen; "; // the rest default to Int
	char *SYMS =
		"_BOUND:int->int->int->int; "
		"_null:int->string; "
		"_ftr:int->string; "
		"_hdr:int->string; "
		"_append:string->int->string; "
		"_decode:string->string; "
		"_encode:int->int->string; "
		"_get:string->int->int; "
		"_pair:int->string->string; "
		"_fst:string->string; "
		"_snd:string->string; "
		;
#include "uu-axioms.h"

  char* NOTES = 
	  "ExpectedSolution : "
	  " &&& "
	  "Benchmark : uuencode";
}